/*********************************************************************************
*	 FileName:  device.h									                                         *
*  Module:  	Device Class Definition for PASS Library DLL.                      *
*  Version:		0.0                                                                *
*  Date:			12/14/93                                                           *
*  Author:		L. Allen                                                           *
*                                                                                *
*  Update History                                                                *
*                                                                                *
*  update    ver   description (author)                                          *
*  -------   ---   -----------                                                   *
*  9312.14   0.0   Work begun. (LA)                                              *
*                                                                                *
*	 Description:                                                                  *
*                                                                                *
*  This is the header file for the device class for the ABI-PC2 board.           *
*                                                                                *
**********************************************************************************/
#ifndef DEVICE_H
#define DEVICE_H

#ifndef _OWL_H
 #include <owl.h>
#endif

#ifndef _WINDOWS_H
#include <windows.h>
#endif

#ifndef _STDIO_H
 #include <stdio.h>
#endif

#define MemSize 0x20000L
#define MapAdr 0xd


_CLASSDEF (TDevice)

class TDevice 
{
  public:

   unsigned int selector;
   long linearadr;
   WORD io;
   WORD baseadr;
   WORD interupt;
   PTWindowsObject parentwin;
   BOOL DeviceOk, SelectorOk, TransDone;



   TDevice(PTWindowsObject AParent, WORD IO, WORD MEMBASE,WORD INTLEVEL);
   virtual ~TDevice(void);
   virtual WORD gr(WORD adr);
   virtual void pr(WORD adr, WORD val);
   virtual BOOL start_uc(void);
   virtual void stop_uc(void);
   virtual void start_monitor(void);
   virtual void stop_monitor(FILE *OPENFILE);
 };
 #endif