/*********************************************************************************
*	 FileName:  msgwin.cpp   									                                     *
*  Module:  	Message Window for PASS Library DLL.                               *
*  Version:		0.0                                                                *
*  Date:			12/16/93                                                           *
*  Author:		L. Allen                                                           *
*                                                                                *
*  Update History                                                                *
*                                                                                *
*  update    ver   description (author)                                          *
*  -------   ---   -----------                                                   *
*  9312.16   0.0   Work begun. (LA)                                              *
*                                                                                *
*	 Description:                                                                  *
*                                                                                *
*  This module defines a hidden window for handling writing the ABI-PC2's        *
*  monitor buffers to an open file.                                              *
*                                                                                *
**********************************************************************************/
#ifndef POINTERS_H
 #include "pointers.h"
#endif

extern "C"
{
 #include "sbsdpmi2.h"
}
#include <owl.h>
#include <math.h>
#include "device.h"
#include "msgwin.h"


TMsgWin::TMsgWin(PTWindowsObject AParent, LPSTR AName,PTModule AModule,
          TDevice *MON, FILE *SAVEFILE,long int FILESIZE):TWindow(AParent,AName,AModule)
 {
  
   savefile = SAVEFILE;
   monitor = MON;
   filesize = FILESIZE;
   Attr.Style |= WS_POPUP | WS_CAPTION | WS_VISIBLE;
   Attr.X = Attr.Y = 0;
   Attr.W = Attr.H =300;
   

/*   buffer_size = (PI_MBLEN + BUF_COR) *2;
   buf_count = floor(filesize / buffer_size);
   if(buf_count<1)
     buf_count = 1;
   block_count = 0;
   intcount = 0;
   callcount = 0;
   m1ptr = (USHORT *)MK_FP(monitor->selector,(PI_M1PTR * 2));
   m2ptr = (USHORT *)MK_FP(monitor->selector,(PI_M2PTR * 2));
   MessageBox(0,"MsgWin initiated.","PASS DLL Message",MB_OK); */
 }

LPSTR TMsgWin::GetClassName()
 {
  return "TMsgWin";
 }

void TMsgWin::GetWindowClass(WNDCLASS& AWndClass)
 {
   TWindow::GetWindowClass(AWndClass);
 }

void TMsgWin::WriteFile(RTMessage Msg)
 {
/*  WORD imon;
  callcount++;
  MessageBox(0,"WriteFile Entered","PASS DLL Message",MB_OK);
  if(block_count < buf_count)
  {
   imon = monitor->gr(PT_IMON);
   if(imon >= 1)
   {
    while((imon >= 1) && (block_count < buf_count))
    {
     // add imon to intcount to keep track of total number of interrupts
     // generated by the PASS board.
     intcount += imon;

     // clear imon
     monitor->pr(PT_IMON,0);

     // find inactive buffer
     if(monitor->gr(PT_M2PTR) == PI_M1PTR)
      fwrite(m1ptr, buffer_size,1,savefile);
     else
      fwrite(m2ptr, buffer_size,1,savefile);

     block_count++;

     // Recheck Imon for a buffer swap during file write. If one has occcured,
     // write next buffer before returning.
     imon = monitor->gr(PT_IMON);

    } // end while

    // Reset IMON and IRSP on monitor board
    monitor->pr(PT_IMON, 0);
    monitor->pr(PT_IRSP, 0);

    // If buf_count has been reached stop board monitor function
    if(block_count >= buf_count)
     {
      block_count =  buf_count;
      monitor->stop_monitor(savefile);
     }
   }  // end if imon>1
  }   // end block_count < buf_count
  else
   monitor->stop_monitor(savefile); */
 }


void TMsgWin::WriteLastBuf(void)
 {
/*  WORD lastword, curptr;
  int i;
  char msgbuf[240];

  // Get position of next unfilled data word
  lastword = monitor->gr(PT_MPOS);
  if(!(monitor->TransDone))
  {
   // Check to see if transfer has started
   if(lastword > PI_M1PTR)
   {
    curptr = monitor->gr(PT_M1PTR);

    // fill next five word block with 0xffff as a marker for end of valid data
    for(i=0;i<6;i++)
     monitor->pr(lastword+i,0xffff);

    // Write last buffer to file
    if(curptr == PI_M1PTR)
     fwrite(m1ptr, buffer_size,1,savefile);
    else
     fwrite(m2ptr, buffer_size,1,savefile);

    callcount++;
    block_count++;
   }
  }

  sprintf(msgbuf,
  "Calls to Write Buffer = %d \n Interrupts Generated = %d \n Buffers Written = %d",
  callcount, intcount, block_count);

  MessageBox(0, msgbuf,"PASS DLL Message", MB_OK);
  */
 }
