/*********************************************************************************
*  FileName:  msgwin.h   									                                       *
*  Module:  	Header for Message Window for PASS Library DLL.                    *
*  Version:		0.0                                                                *
*  Date:			12/13/93                                                           *
*  Author:		L. Allen                                                           *
*                                                                                *
*  Update History                                                                *
*                                                                                *
*  update    ver   description (author)                                          *
*  -------   ---   -----------                                                   *
*  9312.13   0.0   Work begun. (LA)                                              *
*                                                                                *
*	 Description:                                                                  *
*                                                                                *
*  This module defines a hidden window for handling writing the ABI-PC2's        *
*  monitor buffers to an open file.                                              *
*                                                                                *
**********************************************************************************/
#ifndef MSGWIN_H
#define MSGWIN_H

#ifndef _OWL_H
 #include <owl.h>
#endif

#ifndef _STDIO_H
 #include <stdio.h>
#endif

#ifndef DEVICE_H
 #include "device.h"
#endif

#define USHORT unsigned short far



_CLASSDEF (TMsgWin)
class TMsgWin : public TWindow
{
  public:

   PTWindowsObject parentwin;
   TDevice *monitor;
   FILE *savefile;
   long int filesize,buf_count,block_count;
   USHORT *m1ptr, *m2ptr;
   int buffer_size,intcount;
   int callcount;

   TMsgWin(PTWindowsObject AParent, LPSTR AName,PTModule AModule,
           TDevice *MON, FILE *SAVEFILE,long int FILESIZE);
   void GetWindowClass(WNDCLASS& AWndClass);
   LPSTR GetClassName(void);
   virtual void WriteFile(RTMessage Msg) = [WM_USER +150];
   virtual void WriteLastBuf(void);
 };
 #endif



