/************************************************************************
*                                                                       *
*                        PASSTest.cpp                                   *
*                                                                       *
*    A Simple Windows Test of the PASS-LIB.DLL                          *
*                                                                       *
************************************************************************/



#include <owl.h>
#include <stdio.h>
#include <string.h>
#include "passlib.h"

#define CM_INIT   101
#define CM_DIS80  102
#define CM_F2040  103
#define CM_D2040  104
#define CM_CLOSE  105
#define CM_POINTER 201

class TPASSTest : public TApplication {
public:
  TPASSTest(LPSTR Name, HINSTANCE hInstance,
		  HINSTANCE hPrevInstance, LPSTR lpCmd,
		  int nCmdShow)
	        : TApplication(Name, hInstance,
			       hPrevInstance, lpCmd, nCmdShow) {};
  virtual void InitMainWindow();
};

class TTestWindow : public TWindow {
public:
  TTestWindow(PTWindowsObject AParent, LPSTR ATitle);
  virtual void CMINIT(TMessage& Msg)  = [CM_FIRST + CM_INIT];
  virtual void CMDIS80(TMessage& Msg) = [CM_FIRST + CM_DIS80];
  virtual void CMF2040(TMessage& Msg) = [CM_FIRST + CM_F2040];
  virtual void CMD2040(TMessage& Msg) = [CM_FIRST + CM_D2040];
  virtual void CMCLOSE(TMessage& Msg) = [CM_FIRST + CM_CLOSE];
  virtual void CMPOINTER(TMessage& Msg) = [CM_FIRST + CM_POINTER];
};

TTestWindow::TTestWindow(PTWindowsObject AParent, LPSTR ATitle)
  : TWindow(AParent, ATitle)
{
  AssignMenu("MAINMENU");
}

void TTestWindow::CMINIT(TMessage&)
{
  InitMonitor(HWindow,0x391,0xf2,15);
  StartUC();
}

void TTestWindow::CMDIS80(TMessage&)
{
  WORD data[24];
  char msgbuf[240];
  char temp[7];
  int i;

  strcpy(msgbuf,"");
  strcpy(temp,"");

  for(i=0;i<24;i++)
   {
     data[i] = MGR(0x80+i);
     sprintf(temp,"%04X  ",data[i]);
     strcat(msgbuf,temp);
     if((i+1)%8 ==0)
      strcat(msgbuf,"\n");
   } 
  MessageBox(HWindow,msgbuf,"Monitor values from 80h to 98h",MB_OK);
}

void TTestWindow::CMF2040(TMessage&)
{
  int i;

  for(i=0;i<24;i++)
    MPR(0x2040+i,i);
}
void TTestWindow::CMD2040(TMessage&)
{
  WORD data[24];
  char msgbuf[240];
  char temp[7];
  int i;

  strcpy(msgbuf,"");
  strcpy(temp,"");

  for(i=0;i<24;i++)
   {
     data[i] = MGR(0x2040+i);
     sprintf(temp,"%04X  ",data[i]);
     strcat(msgbuf,temp);
     if((i+1)%8 ==0)
      strcat(msgbuf,"\n");
   } 
  MessageBox(HWindow,msgbuf,"Monitor values from 2040h to 2058h",MB_OK);
}
void TTestWindow::CMCLOSE(TMessage&)
{
  StopUC();
  CloseMonitor();
  this->CloseWindow();
}

void TTestWindow::CMPOINTER(TMessage&)
{
  WORD v2040;
  FILE *testfile;
  char msgbuf[8];

  v2040 = MGR(0x2040);
  sprintf(msgbuf,"%0X",v2040);
  MessageBox(HWindow,msgbuf,"Monitor Value at 2040h before InitLogging",MB_OK);
  //testfile = fopen("test","wb");
  InitializeLog(testfile,100);
  //fclose(testfile);
  v2040 = MGR(0x2040);
  sprintf(msgbuf,"%0X",v2040);
  MessageBox(HWindow,msgbuf,"Monitor Value at 2040h after InitLogging",MB_OK);
}



  
void TPASSTest::InitMainWindow()
{
  MainWindow = new TTestWindow(NULL, "Create a DLL Window");
}

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
		   LPSTR lpCmd, int nCmdShow)
{
  TPASSTest PASSTestApp("PASSTEST", hInstance, hPrevInstance,
		lpCmd, nCmdShow);
  PASSTestApp.Run();
  return(PASSTestApp.Status);
}
